void boot_program_page (uint32_t page, uchar *data) 
{ 
    uint16_t i; 
    uint8_t sreg; 

    // Disable interrupts.	 

    sreg = SREG; 
    cli(); 
    
    eeprom_busy_wait (); 

    boot_page_erase (page); 
    //boot_spm_busy_wait ();      // Wait until the memory is erased. Not needed (the cpu is already stopped for the whole duration)
    
    for (i=0; i<SPM_PAGESIZE; i+=2) 
    {        
    //Fill buffer 
      boot_page_fill (page + i, data[i]+(data[i+1]<<8)); 
    } 

    boot_page_write (page);     // Store buffer in flash page. 
    sei(); 

    SREG = sreg; 
} 

