#undef  fcryst
#define fcryst fcr.qw
extern freq_t fcr ;   //crystal frequency [MHz]*2^24fs
extern void SI570_Load(void);
#undef _2
#define _2(x) (1UL << x)
extern char SetFrequency(void);
extern unsigned long frequency;
extern unsigned char I2C_adr;

// *** WARNING *** All data used by the 'rewritable' (aka 'user') code must be separated
// into a separate segment using the USERDATA macro. This prevents new variables in the
// user code from relocating variables used by the code which is NOT rewritten.
// *** ALSO NOTE *** USERDATA variables are never initialised by the C startup code, so
// a declaration of the form "USERDATA int fred = 5;" does not have the expected effect -
// the value of fred at startup is undefined, and the "=5" part is silently ignored. USERDATA
// variable must be explicitly initialised before use.


USERDATA signed char Si570_freq_mult;
USERDATA signed char Si570_freq_div;
USERDATA long Si570_freq_offset;
USERDATA unsigned long Si570_centre;				// Frequency for last full reprogram of the Si570
USERDATA uchar Si570_centre_regs[2];

USERDATA signed char MemorySpace;					// for save/recall frequency
USERDATA signed char OffsetSign;					// selected sign of frequency offset (1:+,0:-)

USERDATA volatile char fmult, fsep;
char units[] STRINGS={' ',10,'k',7,'M',4,'G',1};
USERDATA uint8_t unit;
extern unsigned char SI570_data[6];
extern unsigned char byte_adr;


#ifdef LCD_ON
	char SetFreqAndDisplay(void) REWRITABLE;
	char SetFreqAndDisplay(void){
	long2bcd(freq.qw);
	LCD_SetCommand();
	LCD_Cur(0);
	LCD_SetData();
	LCD_OutNumber(bcd, 10, fsep, fmult);
	LCD_SendByte('H');
	LCD_SendByte('z'); 
	return SetFrequency();
	}
#endif

// Initialise 'USERDATA' vars - these are not automatically handled by the C startup code.
void InitVars(void) REWRITABLE;
void InitVars(void){
uchar   i;
//    for(;;) wdt_reset(); // simulate corrupt inivars procedure with hangup 

#ifdef PORTA_DDR
	DDRA = PORTA_DDR;			//set which Port A pins are outputs
	PORTA = PORTA_INIT;			//set outputs to initial state
#endif

#ifdef PORTB_DDR
	DDRB = PORTB_DDR;			//set which Port B pins are outputs
	PORTB = PORTB_INIT;			//set outputs to initial state
#endif

#ifdef DG8SAQ_I2C
	I2C_MINTIME = 10;
#endif
byte_adr = 7;
fcryst=114.285*_2(19)*_2(5); 							//initialize fcryst to crystal frequency[MHz]*2^24
I2C_adr=0x55;
i = eeprom_read_byte((uint8_t *)I2C_ADR);
if (i!=0xFF) I2C_adr=i;
if (eeprom_read_byte((uint8_t *)F_CRYST_STATUS)!=0xff) //  read calibrated crystal frequency if available
  {
	for (i=0;i<4;i++)
	   fcr.bytes[i]=eeprom_read_byte((uint8_t *)(i+F_CRYST)); //read f_cryst from EEPROM if available
  }
i = eeprom_read_byte((uint8_t *)INIT_SI570); 	//  read init status = I2C address for SI570
if (i!=0xff) 									//USB_SYNTH mode with remember frequency on startup	
	{
	I2C_adr = i;
	for (i=0;i<6;i++)							//  Load frequency preset if available / USB_Synth compatibility
		{
		 SI570_data[i]=eeprom_read_byte((uint8_t *)(i+INIT_FREQ)); //read init frequency from EEPROM if available
		}
	SI570_Load();
	}
	else
	{
#if MODE == VFO
	frequency=0;
	Si570_centre = 0;
	Si570_freq_mult = DEF_FREQ_MULT;
	Si570_freq_div = DEF_FREQ_DIV;
	Si570_freq_offset = 0;
	if (eeprom_read_byte((uint8_t *)(DEFD))==0) RecallFrequency(0); //restore last settings if available
	freq.qw=frequency;
	unit=2;
	wheel=0;
	oldwheel=0;
	oldbutton=0x40;
	menu=MENU_TUNE;
	digit=0;
	menupos=10;
	fmult='M';
	fsep=4;
	select_menu=0;
	OffsetSign=0;
	MemorySpace=1;
	LCD_InitPort();
	LCD_Init(LCD_DISPLAY_ON);
	LCD_InitPort();
	LCD_Init(LCD_DISPLAY_ON);
	SetFreqAndDisplay();
	PCMSK |= (1<<PCINT5); 	//  tell pin change mask to listen to pin1/PCINT5
	GIMSK |= (1<<PCIE); 	// enable PCINT interrupt in the general interrupt mask
	Timer0_On();
#endif
	}
// do the following via USB command 0xEC during program development 
// to make sure you don't lock yourself out if your user code fails to work correctly
eeprom_write_byte((uint8_t *)SAFETY_FLAG,0xFF); //reset safety flag, otherwise InitVars will not be called after next program start
/* below code to modify safety flag handling
int adr;
unsigned char page[SPM_PAGESIZE];
adr=0x558;									//Watchdog setting
bootpage=adr & ~(SPM_PAGESIZE-1);
for (i=0;i<SPM_PAGESIZE;i++){				//read page to be changed
		page[i]=pgm_read_byte (bootpage+i);}
if (page[adr & (SPM_PAGESIZE-1)]==0x8F) return; //return if firmware already updated
page[adr & (SPM_PAGESIZE-1)]=0x8F;			//change byte1
page[(adr+1) & (SPM_PAGESIZE-1)]=0xEF;		//change byte2
boot_program_page (bootpage, page);	//selfflash
*/
}

